/******************************************************************************

	Subject.h Hader of subjcet. It implement observer pattern obejct 

   Author : Luca Strabla (Bassano Bresciano Observatory)

   Date : 		April 2009

   Polypus - Astromonical observatory manager able to take care of
   unmanned observation
   Copyright (C) 2009,2010,2011  Luca Pietro Strabla
   This file is part of Polipus.
   Polypus is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License.

   Polypus is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   mail   contact: Luca Pietro Strabla via Paolo Vi 53 Palazzolo Sull'Oglio BS Italy
   e-mail contact: lucapietro.strabla@fastwebnet.it 

******************************************************************************/



// include atirepeat
#ifndef SubjectH
#define SubjectH



// sistem include
#include <vector.h>



// project include
#include "Observer.h"



class Subject
{
	public:
      // object constructor
                                       Subject( );
      // destroyer
      virtual                          ~Subject( );
      // add an observer to the list
      int                              Attach( Observer *Obj );
      // remove an observer from the list
      int                              Detach( Observer *Obj );
      // event notify to all observer gente della notifica 
      int                              Notify( Observer *Source, int NotifyCode );
   private:
      // observer list
      vector<Observer*>                ListaObj;
};


#endif
