// ************************************************************************ //
// WARNING                                                                    
// -------                                                                    
// The types declared in this file were generated from data read from a       
// Type Library. If this type library is explicitly or indirectly (via        
// another type library referring to this type library) re-imported, or the   
// 'Refresh' command of the Type Library Editor activated while editing the   
// Type Library, the contents of this file will be regenerated and all        
// manual modifications will be lost.                                         
// ************************************************************************ //

// C++ TLBWRTR : $Revision: 1.1 $
// File generated on 17/10/2011 13:49:23 from Type Library described below.

// ************************************************************************  //
// Type Lib: pinpoint.dll (1)
// LIBID: {9B7024E0-BD35-11D2-8EE4-0080C70A9C3D}
// LCID: 0
// Helpfile: 
// HelpString: PinPoint Astrometric Engine
// DepndLst: 
//   (1) v2.0 stdole, (C:\WINDOWS\system32\stdole2.tlb)
// Errors:
//   Error creating palette bitmap of (TPlate) : Server C:\Programmi\File comuni\ASCOM\PinPoint\PinPoint.dll contains no icons
// ************************************************************************ //

#include <vcl.h>
#pragma hdrstop

#include <olectrls.hpp>
#include <oleserver.hpp>
#if defined(USING_ATL)
#include <atl\atlvcl.h>
#endif

#include "PinPoint_OCX.h"

#if !defined(__PRAGMA_PACKAGE_SMART_INIT)
#define      __PRAGMA_PACKAGE_SMART_INIT
#pragma package(smart_init)
#endif

namespace Pinpoint_tlb
{

IPlatePtr& TPlate::GetDefaultInterface()
{
  if (!m_DefaultIntf)
    Connect();
  return m_DefaultIntf;
}

_di_IUnknown __fastcall TPlate::GetDunk()
{
  _di_IUnknown diUnk;
  if (m_DefaultIntf) {
    IUnknownPtr punk = m_DefaultIntf;
    diUnk = LPUNKNOWN(punk);
  }
  return diUnk;
}

void __fastcall TPlate::Connect()
{
  if (!m_DefaultIntf) {
    _di_IUnknown punk = GetServer();
    m_DefaultIntf = punk;
    if (ServerData->EventIID != GUID_NULL)
      ConnectEvents(GetDunk());
  }
}

void __fastcall TPlate::Disconnect()
{
  if (m_DefaultIntf) {
    
    if (ServerData->EventIID != GUID_NULL)
      DisconnectEvents(GetDunk());
    m_DefaultIntf.Reset();
  }
}

void __fastcall TPlate::BeforeDestruction()
{
  Disconnect();
}

void __fastcall TPlate::ConnectTo(IPlatePtr intf)
{
  Disconnect();
  m_DefaultIntf = intf;
  if (ServerData->EventIID != GUID_NULL)
    ConnectEvents(GetDunk());
}

void __fastcall TPlate::InitServerData()
{
  static Oleserver::TServerData sd;
  sd.ClassID = CLSID_Plate;
  sd.IntfIID = __uuidof(IPlate);
  sd.EventIID= __uuidof(_PinPointEvents);
  ServerData = &sd;
}

void __fastcall TPlate::InvokeEvent(int id, Oleserver::TVariantArray& params)
{
  switch(id)
  {
    case 1: {
      if (OnScanProgress) {
        (OnScanProgress)(this, TVariant(params[0]));
      }
      break;
      }
    case 2: {
      if (OnCheckpoint) {
        (OnCheckpoint)(this, TVariant(params[0]));
      }
      break;
      }
    default:
      break;
  }
}


};     // namespace Pinpoint_tlb


// *********************************************************************//
// The Register function is invoked by the IDE when this module is 
// installed in a Package. It provides the list of Components (including
// OCXes) implemented by this module. The following implementation
// informs the IDE of the OCX proxy classes implemented here.
// *********************************************************************//
namespace Pinpoint_ocx
{

void __fastcall PACKAGE Register()
{
  // [1]
  TComponentClass cls_svr[] = {
                              __classid(Pinpoint_tlb::TPlate)
                           };
  RegisterComponents("Servers", cls_svr,
                     sizeof(cls_svr)/sizeof(cls_svr[0])-1);
}

};     // namespace Pinpoint_ocx
